#include <SPI.h>
#include <MFRC522.h>
#include <Servo.h> 

#define SS_PIN 10
#define RST_PIN 9

// 設定電磁閥開關及紅綠燈Pin 值
int servo = 3;
int LEDRed = 7;
int LEDGreen = 6;

Servo lockServo;                //Servo for locking mechanism


MFRC522 mfrc522(SS_PIN, RST_PIN);   // 建立 MFRC522.

void setup()
{
  pinMode(LEDRed, OUTPUT);
  pinMode(LEDGreen, OUTPUT);
  lockServo.attach(3, 800 , 2600); //The range of SG90 is between 800 to 2600 
  lockServo.write(0);         //Move servo into locked position
  Serial.begin(9600);   // 設定串列通訊速率
  SPI.begin();      // 設定  SPI bus
  mfrc522.PCD_Init();   // 設定 MFRC522
  Serial.println(" Put your card close to the reader...im dogdog");
  Serial.println();
}
void loop()
{
  digitalWrite(LEDGreen, LOW);
  digitalWrite(LEDRed, LOW);
  // 是否為新卡？
  if ( ! mfrc522.PICC_IsNewCardPresent())
  {
    return;
  }
  // 選擇一張卡
  if ( ! mfrc522.PICC_ReadCardSerial())
  {
    return;
  }
  //Show UID on serial monitor
  Serial.print("Card No. :");
  String content = "";
  byte letter;
  for (byte i = 0; i < mfrc522.uid.size; i++)
  {
    Serial.print(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " ");
    Serial.print(mfrc522.uid.uidByte[i], HEX);
    content.concat(String(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " "));
    content.concat(String(mfrc522.uid.uidByte[i], HEX));
  }
  Serial.println();
  Serial.print(" Message : ");
  content.toUpperCase();

  //需要改成可通行的卡號
  if (content.substring(1) == "13 DB C4 02")
  {
    Serial.println(" Pass... ");
    Serial.println();
    // 亮綠燈, 電磁閥開
    digitalWrite(LEDGreen, HIGH);
    digitalWrite(LEDRed, LOW);
  lockServo.write(180);
  delay(1000);
  lockServo.write(0);
  delay(1000);
  }

  else   {
    Serial.println(" Stop...");
    // 亮紅燈, 電磁閥關
    digitalWrite(LEDGreen, LOW);
    digitalWrite(LEDRed, HIGH);
    delay(3000);
  }
}
